##layer2kml_v3b=name
##Pasta_de_destino=folder
##Layer_a_converter=vector
from qgis.core import *
from PyQt4.QtGui import *
from qgis.utils import *
import processing
# Verificar se foi escolhida uma pasta de destino
if str(Pasta_de_destino)=="":
    QMessageBox.information(None, "Erro na escolha da pasta de destino", "Precisa escolher uma pasta de destino para o ficheiro a converter.")
else:
    # Activar a layer escolhida para converter a KML
    theactivelayer = processing.getObject(Layer_a_converter)
    iface.setActiveLayer(theactivelayer)
    # Verificar qual EPSG da layer escolhida
    layerCRS = theactivelayer.crs()
    lyrCRS =layerCRS.authid()
    if lyrCRS=="EPSG:102164":
        # Se a layer escolhida tem EPSG=102164 (Lisboa Hayford Gauss IGEOE)
        QMessageBox.information(None, "Nota", "Layer escolhida tem EPSG=102164 (Lisboa Hayford Gauss IGEOE).")
        processing.runandload('qgis:reprojectlayer',Layer_a_converter,'EPSG:4326',None)
        thenewactivelayer = QgsMapLayerRegistry.instance().mapLayersByName("Reprojected")[0]   
        # Colocar o style desta layer intermedia  em linha=vermelho e espessura da linha=2 e fill dos poligonos=transparente
        properties = {"color": "255,0,0,0", "outline_color": "255,0,0",'width_border':'1.2'}
        s = QgsFillSymbolV2.createSimple(properties)
        thenewactivelayer.setRendererV2(QgsSingleSymbolRendererV2(s))
        # Preparar para criar o ficheiro KML e colocar este ficheiro na pasta escolhida pelo utilizador e remover ficheiro intermedio
        layer = processing.getObject(Layer_a_converter)
        layer_name = layer.name()
        dest_crs = QgsCoordinateReferenceSystem(4326)
        QgsVectorFileWriter.writeAsVectorFormat(thenewactivelayer, str(Pasta_de_destino)+"/"+layer_name+".kml",  "utf-8", dest_crs, "KML", symbologyExport=QgsVectorFileWriter.FeatureSymbology)
        QgsMapLayerRegistry.instance().removeMapLayers( [thenewactivelayer.id()] )
    elif lyrCRS=="EPSG:102161":
        # Se a layer escolhida tem EPSG=102161 (Datum 73 Hayford Gauss IPCC)
        QMessageBox.information(None, "Nota", "Layer escolhida tem EPSG=102161 (Datum 73 Hayford Gauss IPCC).")
        processing.runandload('qgis:reprojectlayer',Layer_a_converter,'EPSG:4326',None)
        thenewactivelayer = QgsMapLayerRegistry.instance().mapLayersByName("Reprojected")[0]   
        # Colocar o style desta layer intermedia  em linha=vermelho e espessura da linha=2 e fill dos poligonos=transparente
        properties = {"color": "255,0,0,0", "outline_color": "255,0,0",'width_border':'1.2'}
        s = QgsFillSymbolV2.createSimple(properties)
        thenewactivelayer.setRendererV2(QgsSingleSymbolRendererV2(s))
        # Preparar para criar o ficheiro KML e colocar este ficheiro na pasta escolhida pelo utilizador e remover ficheiro intermedio
        layer = processing.getObject(Layer_a_converter)
        layer_name = layer.name()
        dest_crs = QgsCoordinateReferenceSystem(4326)
        QgsVectorFileWriter.writeAsVectorFormat(thenewactivelayer, str(Pasta_de_destino)+"/"+layer_name+".kml",  "utf-8", dest_crs, "KML", symbologyExport=QgsVectorFileWriter.FeatureSymbology)
        QgsMapLayerRegistry.instance().removeMapLayers( [thenewactivelayer.id()] )
    else:
        # Converter agora para coordenadas geograficas WGS84
        processing.runandload('qgis:reprojectlayer',Layer_a_converter,'EPSG:4326',None)
        thenewactivelayer = QgsMapLayerRegistry.instance().mapLayersByName("Reprojected")[0]   
        # Colocar o style desta layer intermedia  em linha=vermelho e espessura da linha=2 e fill dos poligonos=transparente
        properties = {"color": "255,0,0,0", "outline_color": "255,0,0",'width_border':'1.2'}
        s = QgsFillSymbolV2.createSimple(properties)
        thenewactivelayer.setRendererV2(QgsSingleSymbolRendererV2(s))
        # Preparar para criar o ficheiro KML e colocar este ficheiro na pasta escolhida pelo utilizador e remover ficheiro intermedio
        layer = processing.getObject(Layer_a_converter)
        layer_name = layer.name()
        dest_crs = QgsCoordinateReferenceSystem(4326)
        QgsVectorFileWriter.writeAsVectorFormat(thenewactivelayer, str(Pasta_de_destino)+"/"+layer_name+".kml",  "utf-8", None, "KML", symbologyExport=QgsVectorFileWriter.FeatureSymbology)
        QgsMapLayerRegistry.instance().removeMapLayers( [thenewactivelayer.id()] )

# Sobral Almeida, Outubro/2018